#include<string>
#include<iostream>
#include<boost/regex.hpp>

const boost::regex e("\\A(\\d{3,4})[- ]?(\\d{4})[- ]?(\\d{4})[- ]?(\\d{4})\\z");
const std::string machine_format("\\1\\2\\3\\4");
const std::string human_format("\\4-\\3-\\2-\\1");

std::string machine_readable_card_number(const std::string s)
{
   return regex_replace(s, e, machine_format, boost::match_default | boost::format_sed);
}

std::string human_readable_encoded_number(const std::string s)
{
   return regex_replace(s, e, human_format, boost::match_default | boost::format_sed);
}

int main(int argc, char** argv)
{
  const std::string number = argv[1];
  const std::string machine = machine_readable_card_number(number);
  const std::string encoded = human_readable_encoded_number(number);
  std::cout<<"Org number: "<<number<<std::endl;
  std::cout<<"For the machine: "<<machine<<std::endl;
  std::cout<<"Encoded: "<<encoded<<std::endl;

  return 0;
}
